def freq_touche(_X):
    if 0 < _X < 89:
        return 2 ** ((_X - 49) / 12) * 440
    else:
        return 0

def abs(_X):
    if _X < 0:
        return -_X
    else:
        return _X

def P(_X):
    _X = 1
    for _X in _X(1, _X + 1):
        _X = _X + (-3) ** (-_X) / (2 * _X + 1)
    return _X

def approx_pi(_X):
    return 12 ** 0.5 * _X(_X)

def pi(_X):
    if _X(_X) == 3.141592653589793:
        return _X(_X)
    else:
        return _X.pi

def modulo_2pi(_X):
    return (_X + _X.pi) % (2 * _X.pi) - _X.pi

def approx_sin(_X, _X):
    _X = (_X + _X.pi) % (2 * _X.pi) - _X.pi
    _X = _X
    _X = _X
    for _X in _X(1, _X + 1):
        _X = -_X * _X ** 2 / (2 * _X * (2 * _X + 1))
        _X = _X + _X
    return _X

def discretisation(_X, _X, _X):
    if _X < 2:
        return None
    if _X > _X:
        _X = _X
        _X = _X
        _X = _X
    _X = (_X - _X) / (_X - 1)
    _X = [_X]
    while _X + _X < _X:
        _X = _X + _X
        _X.append(_X)
    return _X

def echantillonnage_note(_X, _X, _X, _X):
    _X = _X(_X * _X)
    _X = _X(0, _X, _X)
    _X = []
    if _X(_X(2 * _X.pi, 100)) < 1e-14:
        for _X in _X:
            _X.append(_X * _X(2 * _X.pi * _X * _X, 100))
    else:
        for _X in _X:
            _X.append(_X * _X.sin(2 * _X.pi * _X * _X))
    return _X

def echantillonnage_partition(_X, _X, _X):
    _X = []
    for _X, _X in _X:
        _X = _X + _X(_X, _X, _X, _X)
    return _X

def echantillonnage_accord(_X, _X, _X, _X):
    _X = _X(_X * _X)
    _X = _X(0, _X, _X)
    _X = []
    if _X(_X(2 * _X.pi, 100)) < 1e-14:
        for _X in _X(_X):
            for _X in _X:
                _X[_X] = _X[_X] + _X * _X(2 * _X.pi * _X * _X[_X], 100)
    else:
        for _X in _X(_X):
            for _X in _X:
                _X[_X] = _X[_X] + _X * _X.sin(2 * _X.pi * _X * _X[_X])
    return _X

def echantillonnage_partition_accords(_X, _X, _X):
    _X = []
    for _X, _X in _X:
        _X = _X + _X(_X, _X, _X, _X)
    return _X

def touche_octave(_X):
    _X = 'CcDdEFfGgAaB'
    for _X in _X(_X(_X)):
        if _X == _X[_X]:
            return _X
    return -1

def touche_piano(_X, _X):
    _X = _X(_X)
    if _X == -1:
        return -1
    else:
        _X = _X - 8 + _X * 12
        return _X

def partition(_X):
    _X = []
    for _X in _X(0, _X(_X), 3):
        _X = _X[_X]
        _X = _X(_X[_X + 1])
        _X = _X(_X[_X + 2]) / 8
        _X = _X(_X, _X)
        if _X != -1:
            _X.append((_X, _X))

def generer_partition(_X, _X, _X, _X):
    _X = _X('song/partition.txt', 'r')
    _X = _X.read()
    _X = _X(_X, _X, _X)
    _X.write(_X, rate=_X, data=_X.array(_X).astype(_X.int16))
    return None