def freq_touche(_X):
    if 0 < _X < 89.9:
        return 2 ** ((_X - 49) / 12) * 440
    else:
        return 0

def abs(_X):
    return (_X ** 2) ** (1 / 2)

def approx_pi(_X):
    if _X == 0:
        return 1
    else:
        _X = 1
        _X = 1
        while _X < _X:
            _X = _X + (-3) ** (-_X) / (2 * _X + 1)
            _X = _X
            _X = _X + 1
        return 12 ** 0.5 * _X

def modulo_2pi(_X):
    _X = _X % (2 * _X)
    if _X > _X:
        _X = _X - 2 * _X
    elif _X <= -_X:
        _X = _X + 2 * _X
    return _X

def approx_sin(_X, _X):
    _X = _X(_X)
    _X = _X
    _X = 1
    _X = 0
    if _X == 0:
        return _X
    else:
        while _X != _X:
            _X = -_X * (_X ** 2 / (2 * _X * (2 * _X + 1)))
            _X = _X
            _X = _X + 1
            _X = _X + _X
    return _X

def discretisation(_X, _X, _X):
    _X = (_X - _X) / _X
    _X = _X
    _X = []
    _X.append(_X)
    while _X < _X - _X:
        _X = _X + _X
        _X.append(_X)
    return _X

def echantillonnage_note(_X, _X, _X, _X):
    _X = []
    _X = _X(0, _X / 8, _X * _X)
    _X.append(_X * _X.sin(2 * _X * _X * _X))
    return _X

def echantillonnage_partition(_X, _X, _X):
    _X = []
    for _X, _X in _X:
        _X = _X(_X, _X, _X, _X)
        _X.append(_X)
    return _X

def touche_octave(_X):
    _X = 'CcDdEFfGgAaB'
    _X = 0
    while _X != 12:
        if _X == _X[_X]:
            return _X
        else:
            _X = _X + 1
    return -1

def touche_piano(_X, _X):
    _X = _X(_X)
    if _X == -1:
        return -1
    return _X - 8 + _X(_X) * 12

def partition(_X):
    _X = 0
    _X = []
    while _X + 3 <= _X(_X):
        _X = _X[_X]
        _X = _X[_X + 1]
        _X = _X[_X + 2]
        _X.append((_X(_X, _X), _X))
        _X = _X + 3
    return _X