def freq_touche(_X):
    if 0 < _X < 89:
        return 2 ** ((_X - 49) / 12) * 440
    return 0

def abs(_X):
    if _X >= 0:
        _X = _X
    else:
        _X = -_X
    return _X

def suite_pi(_X):
    if _X == 0:
        return 1
    else:
        return _X(_X - 1) + (-3) ** (-_X) / (2 * _X + 1)

def approx_pi(_X):
    return _X(_X) * 12 ** (1 / 2)

def modulo_2pi(_X):
    while _X <= -_X or _X > _X:
        _X = _X - 2 * _X
    return _X

def suite_sinus(_X, _X):
    _X('sinus(' + _X(_X) + ',' + _X(_X))
    if _X == 0:
        _X('RETURN x : ' + _X(_X))
        return _X
    return -_X(_X, _X - 1) * _X ** 2 / (2 * _X * (2 * _X + 1))

def approx_sin(_X, _X):
    _X = _X(_X)
    return _X(_X, _X)

def discretisation(_X, _X, _X):
    if _X >= _X or _X < 2:
        return []
    _X = (_X - _X) / (_X - 1)
    return [_X + _X * _X for _X in _X(_X)]

def sin(_X):
    return _X.sin(_X)

def echantillonnage_note(_X, _X, _X, _X):
    _X = _X(0, _X, _X * _X)
    return [_X * _X(2 * _X * _X * _X) for _X in _X]

def echantillonnage_partition(_X, _X, _X):
    _X = []
    for _X in _X:
        _X, _X = _X
        _X = _X(_X)
        _X.extend(_X(_X, _X, _X, _X))
    return _X

def wave_partition():
    _X = 44100
    _X = 2048
    _X = [(40, 16), (42, 16), (44, 16), (45, 16), (47, 16), (49, 16), (51, 16)]
    _X = _X(_X, _X, _X)
    _X.write(' octave4_2s.wav', rate=_X, data=_X.array(_X).astype(_X.int16))

def valeur_accord(_X, _X):
    _X = 0
    for _X in _X:
        _X += _X(2 * _X * _X * _X)
    return _X

def echantillonnage_accord(_X, _X, _X, _X):
    _X = _X(0, _X, _X * _X)
    return [_X * _X(_X, _X) for _X in _X]

def echantillonnage_partition_accords(_X, _X, _X):
    _X = []
    for _X in _X:
        _X, _X = _X
        _X = [_X(_X) for _X in _X]
        _X.extend(_X(_X, _X, _X, _X))
    return _X

def wave_partition_accord():
    _X = 44100
    _X = 2048
    _X = [([49, 52, 45], 16), ([49], 8), ([42, 46, 49], 16)]
    _X = _X(_X, _X, _X)
    _X.write(' accords.wav', rate=_X, data=_X.array(_X).astype(_X.int16))

def touche_octave(_X):
    _X = ['C', 'c', 'D', 'd', 'E', 'F', 'f', 'G', 'g', 'A', 'a', 'B']
    try:
        return _X.index(_X)
    except _X:
        return -1

def touche_piano(_X, _X):
    _X = _X + 1
    _X = _X(_X)
    if _X == -1:
        return -1
    return _X - 8 + 12 * _X

def partition(_X):
    _X = [_X[_X:_X + 3] for _X in _X(0, _X(_X), 3)]
    return [(_X(_X[0], _X(_X[1])), _X(_X[-1])) for _X in _X]

def generer_partition(_X, _X, _X, _X):
    _X = _X(_X, 'r')
    _X = _X(_X(_X.read()), _X, _X)
    _X.write(_X, rate=_X, data=_X.array(_X).astype(_X.int16))

def test():
    _X = 1e-14
    assert _X(90) == 0
    assert _X(49) == 440
    assert _X(3) == 3
    assert _X(-3) == 3
    assert _X(0) == 0
    assert _X(40) == _X(100)
    assert _X.isclose(_X(1.5), 1.5, abs_tol=_X)
    assert _X.isclose(_X(2 * _X.pi + 1), 1, abs_tol=_X)
    assert _X.isclose(_X.sin(0), 0, abs_tol=_X)
    assert _X.isclose(_X.sin(_X.pi / 2), 1, abs_tol=_X)
    assert _X.isclose(_X.sin(_X.pi), 0, abs_tol=_X)
    assert _X(0.0, 10.0, 5) == [0.0, 2.5, 5.0, 7.5, 10.0]
    _X()
    _X()
    assert _X(50, 2, 10, 2)
    assert _X('D') == 2
    assert _X('D', 4) == 54
    assert _X('U', 4) == -1
    assert _X('C41D41') == [(52, 1), (54, 1)]
    assert _X('songs/boat.txt', 'melodie_boat.wav', 44100, 2046) == None
    _X('test ok')