def freq_touche(_X):
    if 0 < _X < 89:
        return 2 ** ((_X - 49) / 12) * 440
    else:
        return 0

def abs(_X):
    return _X if _X >= 0 else -_X

def approx_pi(_X):
    _X = 1
    for _X in _X(1, _X + 1):
        _X += (-3) ** (-_X) / (2 * _X + 1)
    return _X.sqrt(12) * _X

def modulo_2pi(_X):
    return (_X + _X) % (2 * _X) - _X

def approx_sin(_X, _X):
    _X = _X(_X)
    _X = _X
    _X = _X
    for _X in _X(1, _X + 1):
        _X *= -_X ** 2 / (2 * _X * (2 * _X + 1))
        _X += _X
    return _X

def discretisation(_X, _X, _X):
    return [_X + (_X - _X) * _X / (_X - 1) for _X in _X(_X)]

def echantillonnage_note(_X, _X, _X, _X):
    _X = _X(0, _X / 8, _X(_X * _X / 8))
    return [_X * _X.sin(2 * _X * _X * _X) for _X in _X]

def echantillonnage_partition(_X, _X, _X):
    _X = []
    for _X, _X in _X:
        _X = _X(_X)
        _X += _X(_X, _X, _X, _X)
    return _X

def echantillonnage_accord(_X, _X, _X, _X):
    _X = _X(0, _X / 8, _X(_X * _X / 8))
    return [_X * _X((_X.sin(2 * _X * _X * _X) for _X in _X)) for _X in _X]

def echantillonnage_partition_accords(_X, _X, _X):
    _X = []
    for _X, _X in _X:
        _X = [_X(_X) for _X in _X]
        _X += _X(_X, _X, _X, _X)
    return _X
    _X = [([49, 52, 45], 16), ([49], 8), ([42, 46, 49], 16)]
    _X = _X(_X, _X, _X)
    _X.write('accords.wav', rate=_X, data=_X.array(_X).astype(_X.int16))

def touche_octave(_X):
    _X = 'CcDdEFfGgAaB'
    return _X.find(_X)

def touche_piano(_X, _X):
    _X = _X(_X)
    if _X == -1:
        return -1
    return 1 + _X + _X * 12 if 1 <= _X + _X * 12 <= 88 else -1

def partition(_X):
    _X = []
    for _X in _X(0, _X(_X), 3):
        _X, _X, _X = (_X[_X], _X(_X[_X + 1]), _X(_X[_X + 2]))
        _X.append((_X(_X, _X), _X))
    return _X

def generer_partition(_X, _X, _X, _X):
    with _X(_X, 'r') as _X:
        _X = _X.read().strip()
    _X = _X(_X)
    _X = _X(_X, _X, _X)
    _X.write(_X, rate=_X, data=_X.array(_X).astype(_X.int16))