def freq_touche(_X):
    if 0 < _X < 89:
        return 2 ** ((_X - 49) / 12) * 440
    return 0

def abs(_X):
    if _X > 0:
        return _X
    return -_X

def approx_pi(_X):
    _X = 1
    for _X in _X(1, _X + 1):
        _X += (-3) ** (-_X) / (2 * _X + 1)
    return _X.sqrt(12) * _X

def pi():
    if _X(_X.pi - _X(40)) < 1e-14:
        return _X(40)
    return _X.pi

def modulo_2pi(_X):
    if _X > 0:
        while _X > _X:
            _X -= 2 * _X
    while _X < -_X:
        _X += 2 * _X
    return _X

def approx_sin(_X, _X):
    _X = _X(_X)
    _X = _X
    _X = _X
    for _X in _X(1, _X + 1):
        _X = -_X * (_X ** 2 / (2 * _X * (2 * _X + 1)))
        _X += _X
    return _X

def discretisation(_X, _X, _X):
    _X = _X(_X)
    _X = (_X - _X) / (_X - 1)
    _X = []
    for _X in _X(_X):
        _X.append(_X + _X * _X)
    return _X

def echantillonnage_note(_X, _X, _X, _X):
    _X = _X(0, _X / 8, _X * _X / 8)
    _X = []
    for _X in _X:
        _X.append(_X * _X.sin(2 * _X * _X * _X))
    return _X

def echantillonnage_partition(_X, _X, _X):
    _X = 440
    _X = []
    for _X, _X in _X:
        _X = _X(_X, _X, _X, _X)
        for _X in _X:
            _X.append(_X)
    return _X

def echantillonnage_accord(_X, _X, _X, _X):
    _X = _X(0, _X, _X * _X)
    _X = []
    for _X in _X:
        _X = 0
        for _X in _X:
            _X += _X * _X.sin(2 * _X * _X * _X)
        _X.append(_X)
    return _X

def echantillonnage_partition_accords(_X, _X, _X):
    _X = []
    for _X, _X in _X:
        _X = _X(0, _X, _X * _X)
        _X = []
        for _X in _X:
            _X = 0
            for _X in _X:
                _X = _X(_X)
                _X += _X * _X.sin(2 * _X * _X * _X)
            _X.append(_X)
        for _X in _X:
            _X.append(_X)
    return _X

def touche_octave(_X):
    _X = ['C', 'c', 'D', 'd', 'E', 'F', 'f', 'G', 'g', 'A', 'a', 'B']
    for _X in _X(_X(_X)):
        if _X[_X] == _X:
            return _X
    return -1

def touche_piano(_X, _X):
    _X = _X(_X)
    if _X == -1:
        return -1
    _X = _X + _X * 12 + 1
    if 1 <= _X <= 88:
        return _X
    return -1

def conversion_entier(_X):
    _X = ['0', '1', '2', '3', '4', '5', '6', '7', '8', '9']
    for _X in _X(_X(_X)):
        if _X[_X] == _X:
            return _X
    return -1

def partition(_X):
    _X = []
    for _X in _X(0, _X(_X), 3):
        _X = _X[_X]
        _X = 0
        for _X in _X[_X + 1]:
            _X = _X * 10 + _X(_X)
        _X = 0
        for _X in _X[_X + 2]:
            _X = _X * 10 + _X(_X)
        _X = _X(_X, _X)
        if _X != -1:
            _X.append((_X, _X))
    return _X

def generer_partition(_X, _X, _X, _X):
    _X = _X(_X, 'r')
    _X = ''
    while True:
        _X = _X.read(1)
        if _X == '':
            break
        _X += _X
    _X.close()
    _X = _X(_X)
    _X = _X(_X, _X, _X)
    _X.write(_X, rate=_X, data=_X.array(_X).astype(_X.int16))
    return None