def freq_touche(_X):
    if 0 < _X < 89:
        return 440 * 2 ** ((_X - 49) / 12)
    else:
        return 0

def abs(_X):
    if _X >= 0:
        return _X
    else:
        return -_X

def approx_pi(_X):
    if _X == 0:
        _X = 1
    else:
        _X = 1
        for _X in _X(1, _X):
            _X = _X + (-3) ** (-_X) / (2 * _X + 1)
        _X = 12 ** 0.5 * _X
    return _X

def modulo_2pi(_X):
    _X = _X % (2 * _X)
    if _X > _X:
        _X -= 2 * _X
    elif _X <= -_X:
        _X += 2 * _X
    return _X

def approx_sin(_X, _X):
    _X = _X(_X)
    _X = _X
    _X = _X
    if _X == 0:
        _X = 1
    else:
        for _X in _X(1, _X + 1):
            _X = -_X * _X ** 2 / (2 * _X * (2 * _X + 1))
        _X += _X

def discretisation(_X, _X, _X):
    if _X < 2:
        _X = (_X - _X) / (_X - 1)
        _X = [_X + _X * _X for _X in _X(_X)]
    return _X

def echantillonnage_note(_X, _X, _X, _X):
    _X = 0
    _X = _X
    _X = _X(_X * _X)
    _X = _X(_X, _X, _X)
    if _X(_X(2 * _X.pi, 100)) < 1e-14:
        _X = lambda x: _X(_X, 100)
    else:
        _X = _X.sin
    _X = [_X * _X(2 * _X.pi * _X * _X) for _X in _X]
    return _X

def echantillonnage_partition(_X, _X, _X):
    _X = []
    for _X, _X in _X:
        _X = _X / 8
        _X = _X(_X)
        if _X > 0:
            _X = _X(_X, _X, _X, _X)
            _X.extend(_X)
    return _X

def echantillonnage_accord(_X, _X, _X, _X):
    _X = 0
    _X = _X
    _X = _X(_X * _X)
    _X = _X(_X, _X, _X)
    _X = [0.0] * _X
    if _X(_X(2 * _X.pi, 100)) < 1e-14:
        _X = lambda x: _X(_X, 100)
    else:
        _X = _X.sin
    for _X in _X:
        for _X in _X(_X):
            _X[_X] += _X * _X(2 * _X.pi * _X * _X[_X])
    return _X

def echantillonnage_partition_accords(_X, _X, _X):
    _X = []
    for _X, _X in _X:
        _X = _X / 8
        _X = [_X(_X) for _X in _X]
        _X = _X(_X, _X, _X, _X)
        _X.extend(_X)
    return _X

def touche_octave(_X):
    _X = 'CcDdEFfGgAaB'
    for _X, _X in _X(_X):
        if _X == _X:
            return _X
    return -1

def touche_piano(_X, _X):
    _X = _X(_X)
    if _X == -1:
        return -1
    else:
        _X = _X - 8 + _X * 12
        return _X